#include "../../include/all.h"

#include <stdio.h>
#include <stdlib.h>

#define DATA_DIR "/tmp/data"

int main(int argc, char *argv[]) {
  int ret = EXIT_FAILURE;

  if (argc != 2) {
    printf("usage: %s <pool url>\n", argv[0]);
    return ret;
  }

  lm_ctx_t ctx;
  lm_ctx_init(&ctx);

  if (!lm_ctx_set_data(&ctx, DATA_DIR)) {
    printf("failed to set data dir: %s (%d)\n", lm_strerror(), lm_error());
    goto end;
  }

  if (lm_ctx_pool_add(&ctx, "base", argv[1]) == NULL) {
    printf("failed to add pool: %s (%d)\n", lm_strerror(), lm_error());
    goto end;
  }

  lm_ctx_pool_test(&ctx, NULL, NULL);
  lm_ctx_pool_get_info(&ctx, true, true, NULL, NULL);
  lm_ctx_pool_get_list(&ctx, true, true, NULL, NULL);

  if (lm_ctx_package_get(&ctx, "which", NULL) == NULL) {
    printf("failed to get the package: %s (%d)\n", lm_strerror(), lm_error());
    goto end;
  }

  if (!lm_ctx_package_verify(&ctx, "which", NULL)) {
    printf("failed to verify package: %s (%d)\n", lm_strerror(), lm_error());
    goto end;
  }

  ret = EXIT_SUCCESS;

end:
  lm_ctx_free(&ctx);
  return ret;
}
