#pragma once
#include "types.h"
#include <libintl.h>
#include <netinet/in.h>
#include <stdbool.h>
#include <stdio.h>

#define _(x) gettext(x)

bool contains(char *str, char s);
bool eq(char *s1, char *s2);
bool is_letter(char c);
bool is_digit(char c);

bool copy_from_buffer(void *dst, void *buffer, size_t size, ssize_t *total, ssize_t *used);
bool copy_to_buffer(void *buffer, void *src, size_t size, ssize_t *total, ssize_t *used);

bool can_write(char *path);
bool can_read(char *path);
bool is_file(char *path);
bool is_dir(char *path);
bool exists(char *path);

bool package_parse(char *package, char *name, char *version);
bool package_version_valid(char *name);
bool package_name_valid(char *name);

void pdebug(const char *func, const char *fmt, ...);
bool parse_host(char *addr, char *host, uint16_t *port);
bool extract_archive(char *dst, char *src);
bool mkdir_ifnot(char *path);
void sockaddr_to_str(struct sockaddr *addr, char *str);

int   join_multiple(char *res, const char *base, const char *pth, const char *pth2);
int   join(char *res, const char *base, const char *pth);
char *join_alloc(const char *base, const char *pth);
